<?xml version='1.0'?>

<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:csc="http://www.csclub.uwaterloo.ca/cow" 
    extension-element-prefixes="csc">

<xsl:template match="all-books">
  <p>The books we currently own include:</p>
  <table>
    <tr>
      <th>Title</th>
      <th>Author</th>
    </tr>
    <xsl:for-each select="document('../books.xml')/booklist/book">
      <xsl:variable name="class">
        <xsl:choose>
          <xsl:when test="position() mod 2 = 0">books1</xsl:when>
          <xsl:otherwise>books2</xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <tr class="{$class}" >
        <td>
          <a href="{$pre}office/books/{translate(@isbn, ' ', '_')}.html">
            <xsl:value-of select="@title" />
            <xsl:if test="@edition != ''">
              (<xsl:value-of select="@edition" />)
            </xsl:if>
          </a>
        </td>
        <td>
          <xsl:value-of select="@author" />
        </td>
      </tr>
      <xsl:document method="xml" encoding="ISO-8859-1" 
          doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN"
          doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"
          href="{translate(concat($root, '/office/books/', @isbn, '.html'), ' ', '_')}">
        <html>
          <head>
            <title>Book: <xsl:value-of select="@title" /></title>
            <link rel="stylesheet" href="{$pre}default.css" type="text/css" />
          </head>
          <body><div>
            <xsl:call-template name="header">
              <xsl:with-param name="title" select="@title" />
              <!-- TODO -->
              <xsl:with-param name="pwd" select="concat($pwd, '/books')" />
            </xsl:call-template>
            <p>
              <b>Title: </b> <xsl:value-of select="@title" /><br />
              <b>Edition: </b> <xsl:value-of select="@edition" /><br />
              <b>ISBN: </b> <xsl:value-of select="@isbn" /><br />
              <b>Author: </b> <xsl:value-of select="@author" /><br />
              <b>Published: </b> <xsl:value-of select="@published" /><br />
            </p>
            <xsl:call-template name="footer" />
          </div></body>
        </html>
      </xsl:document>
    </xsl:for-each>
  </table>
</xsl:template>

</xsl:stylesheet>
